
#include "bits/radix-m4.h"

#include "bits/graycode.h"

#include "fxttypes.h"  // ulong
#include "bits/bitsperlong.h"

#include "bits/print-bin.h"
#include "fxtiomanip.h"
#include "jjassert.h"
#include "nextarg.h"

//% Representation in radix(-4).

int
main(int argc, char **argv)
{
    ulong ldn = 6;
    NXARG(ldn, "Number of bits");
    ulong n = 1UL<<ldn;
    int pn = (int)ldn + 4;
    pn -= pn&1;

    for (ulong k=0; k<n; ++k)
    {
        ulong m = bin_to_radm4(k);
        ulong g = gray_code(m);
        cout << setw(4) << k;
        print_bin(":  ", k, pn);
        print_bin("    ", m, pn);
        cout << " = [";
        // here the least significant digit appears on the left:
        for (int j=0; j<pn; j+=2)  cout << " " << ((m>>j)&3);
        cout << " ] ";
        print_bin("    ", g, pn);

        cout << endl;

        jjassert( radm4_to_bin(m) == k );
        jjassert( next_radm4(m) == bin_to_radm4(k+1) );
        jjassert( prev_radm4(m) == bin_to_radm4(k-1) );
    }

    cout << endl;

    return 0;
}
// -------------------------


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/radix-m4-demo.cc"
/// make-target2: "1demo DSRC=demo/bits/radix-m4-demo.cc DEMOFLAGS=-DTIMING"
/// End:
