// This file is part of the FXT library.
// Copyright (C) 2010 Joerg Arndt
// License: GNU General Public License version 3 or later,
// see the file COPYING.txt in the main directory.

#include "fxttypes.h"
#include "aux2/array2d.h"


#ifdef  ROW_ASSERTS
#include "jjassert.h"
#include "fxtio.h"
void
row_assert(ulong r, ulong nr)
{
    if ( r>=nr || (long)r<0 )
    {
        cerr << __PRETTY_FUNCTION__ << endl;
        cerr << " r=" << r << "  (nr=" << nr << ")" << endl;
        jjassert( r<nr );
        jjassert( (long)r>=0 );
    }
}
// -------------------------
#else
// inline member function in array2d.h
#endif // ROW_ASSERTS
